org.apache.poi.hssf.record

## Class CFRuleRecord

- java.lang.Object
- - org.apache.poi.hssf.record.RecordBase
  - - org.apache.poi.hssf.record.Record
    - - org.apache.poi.hssf.record.StandardRecord
      - - org.apache.poi.hssf.record.CFRuleBase
        - - org.apache.poi.hssf.record.CFRuleRecord

- All Implemented Interfaces:
    Duplicatable

      public final class CFRuleRecord
      extends CFRuleBase

  Conditional Formatting Rule Record (0x01B1).

  This is for the older-style Excel conditional formattings, new-style (Excel 2007+) also make use of `CFRule12Record` for their rules.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.poi.hssf.record.CFRuleBase

      `CFRuleBase.ComparisonOperator`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static short` | `sid`

    - ### Fields inherited from class org.apache.poi.hssf.record.CFRuleBase

      `_borderFormatting, _fontFormatting, _patternFormatting, CONDITION_TYPE_CELL_VALUE_IS, CONDITION_TYPE_COLOR_SCALE, CONDITION_TYPE_DATA_BAR, CONDITION_TYPE_FILTER, CONDITION_TYPE_FORMULA, CONDITION_TYPE_ICON_SET, formatting_not_used, formatting_options, logger, TEMPLATE_ABOVE_AVERAGE, TEMPLATE_ABOVE_OR_EQUAL_TO_AVERAGE, TEMPLATE_BELOW_AVERAGE, TEMPLATE_BELOW_OR_EQUAL_TO_AVERAGE, TEMPLATE_CELL_VALUE, TEMPLATE_COLOR_SCALE_FORMATTING, TEMPLATE_CONTAINS_BLANKS, TEMPLATE_CONTAINS_ERRORS, TEMPLATE_CONTAINS_NO_BLANKS, TEMPLATE_CONTAINS_NO_ERRORS, TEMPLATE_CONTAINS_TEXT, TEMPLATE_DATA_BAR_FORMATTING, TEMPLATE_DUPLICATE_VALUES, TEMPLATE_FILTER, TEMPLATE_FORMULA, TEMPLATE_ICON_SET_FORMATTING, TEMPLATE_LAST_7_DAYS, TEMPLATE_LAST_MONTH, TEMPLATE_LAST_WEEK, TEMPLATE_NEXT_MONTH, TEMPLATE_NEXT_WEEK, TEMPLATE_THIS_MONTH, TEMPLATE_THIS_WEEK, TEMPLATE_TODAY, TEMPLATE_TOMORROW, TEMPLATE_UNIQUE_VALUES, TEMPLATE_YESTERDAY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CFRuleRecord(CFRuleRecord other)`
    `CFRuleRecord(RecordInputStream in)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `CFRuleRecord` | `clone()` Deprecated.
    `CFRuleRecord` | `copy()`
    `static CFRuleRecord` | `create(HSSFSheet sheet, byte comparisonOperation, java.lang.String formulaText1, java.lang.String formulaText2)` Creates a new comparison operation rule
    `static CFRuleRecord` | `create(HSSFSheet sheet, java.lang.String formulaText)` Creates a new comparison operation rule
    `protected int` | `getDataSize()`
    `short` | `getSid()` return the non static version of the id for this record.
    `void` | `serialize(LittleEndianOutput out)` called by the class that is responsible for writing this sucker.
    `java.lang.String` | `toString()` get a string representation of the record (for biffview/debugging)

    - ### Methods inherited from class org.apache.poi.hssf.record.CFRuleBase

      `containsAlignFormattingBlock, containsBorderFormattingBlock, containsFontFormattingBlock, containsPatternFormattingBlock, containsProtectionFormattingBlock, getBorderFormatting, getComparisonOperation, getConditionType, getFontFormatting, getFormattingBlockSize, getFormula1, getFormula2, getFormulaSize, getOptions, getParsedExpression1, getParsedExpression2, getPatternFormatting, isBottomBorderModified, isBottomLeftTopRightBorderModified, isLeftBorderModified, isPatternBackgroundColorModified, isPatternColorModified, isPatternStyleModified, isRightBorderModified, isTopBorderModified, isTopLeftBottomRightBorderModified, parseFormula, readFormatOptions, serializeFormattingBlock, setAlignFormattingUnchanged, setBorderFormatting, setBottomBorderModified, setBottomLeftTopRightBorderModified, setComparisonOperation, setConditionType, setFontFormatting, setFormula1, setFormula2, setLeftBorderModified, setParsedExpression1, setParsedExpression2, setPatternBackgroundColorModified, setPatternColorModified, setPatternFormatting, setPatternStyleModified, setProtectionFormattingUnchanged, setRightBorderModified, setTopBorderModified, setTopLeftBottomRightBorderModified`

    - ### Methods inherited from class org.apache.poi.hssf.record.StandardRecord

      `getRecordSize, serialize`

    - ### Methods inherited from class org.apache.poi.hssf.record.Record

      `cloneViaReserialise, serialize`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### sid

          public static final short sid

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### CFRuleRecord

          public CFRuleRecord(CFRuleRecord other)

    - #### CFRuleRecord

          public CFRuleRecord(RecordInputStream in)

  - ### Method Detail

    - #### create

          public static CFRuleRecord create(HSSFSheet sheet,
                                            java.lang.String formulaText)

      Creates a new comparison operation rule
      Parameters:
        `sheet` - the sheet
        `formulaText` - the formula text
      Returns:
        a new comparison operation rule

    - #### create

          public static CFRuleRecord create(HSSFSheet sheet,
                                            byte comparisonOperation,
                                            java.lang.String formulaText1,
                                            java.lang.String formulaText2)

      Creates a new comparison operation rule
      Parameters:
        `sheet` - the sheet
        `comparisonOperation` - the comparison operation
        `formulaText1` - the first formula text
        `formulaText2` - the second formula text
      Returns:
        a new comparison operation rule

    - #### getSid

          public short getSid()

      Description copied from class: `Record`
      return the non static version of the id for this record.
      Specified by:
        `getSid` in class `Record`
      Returns:
        he id for this record

    - #### serialize

          public void serialize(LittleEndianOutput out)

      called by the class that is responsible for writing this sucker. Subclasses should implement this so that their data is passed back in a byte array.
      Specified by:
        `serialize` in class `StandardRecord`
      Parameters:
        `out` - the stream to write to

    - #### getDataSize

          protected int getDataSize()

      Specified by:
        `getDataSize` in class `StandardRecord`

    - #### toString

          public java.lang.String toString()

      Description copied from class: `Record`
      get a string representation of the record (for biffview/debugging)
      Overrides:
        `toString` in class `Record`

    - #### clone

          @Deprecated
           @Removal(version="5.0.0")
          public CFRuleRecord clone()

      Deprecated.
      Specified by:
        `clone` in class `CFRuleBase`

    - #### copy

          public CFRuleRecord copy()

      Specified by:
        `copy` in interface `Duplicatable`
      Specified by:
        `copy` in class `CFRuleBase`
      Returns:
        a deep copy of the implementing class / instance

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.